#include "pch.h"
#include "Pointers.h"


//====================================================
//       :
// https://www.interestprograms.ru
//     
//     
//====================================================


//   .
void CSendInfo::Reset()
{
	m_SizeString = 0;
	m_SizeArrayTCHAR = 0;
	m_SizeArrayInt = 0;
	m_TotalDataSize = 0;
}



CPointers::CPointers()
: m_String(_T(""))
, m_pTCHAR(NULL)
, m_pInt(NULL)
, m_pDouble(NULL)
, m_pArrayInt(NULL)
, m_LenArrayTCHAR(0)
, m_LenArrayInt(0)
{
	
}



CPointers::~CPointers()
{
	// ---    ---

	delete[] m_pTCHAR;
	m_pTCHAR = NULL;


	delete m_pInt;
	m_pInt = NULL;

	delete m_pDouble;
	m_pDouble = NULL;

	delete[] m_pArrayInt;
	m_pArrayInt = NULL;

}

//     
LPCTSTR CPointers::GetDataString(int& sizeBytes)
{
	int len = m_String.GetLength();

	int size = len * sizeof(TCHAR) + sizeof(TCHAR);


	sizeBytes = size;

	// https://docs.microsoft.com/ru-ru/cpp/atl-mfc-shared/cstring-operations-relating-to-c-style-strings?view=vs-2019
	//    CString,  SetAt,      
	/* .  ,  LPCTSTR    CString
		,     .CString      ,
		     .     
		CString LPCTSTR   ,    .*/
	return (LPCTSTR)m_String;
}



void CPointers::SetArrayTCHAR(CString s)
{
	m_LenArrayTCHAR = s.GetLength() + 1/* */;

	m_pTCHAR = new TCHAR[m_LenArrayTCHAR];

	_tcscpy_s(m_pTCHAR, m_LenArrayTCHAR, (LPCTSTR)s);
}

int CPointers::GetSizeArrayTCHAR()
{
	int sizeBytes = m_LenArrayTCHAR * sizeof(TCHAR);
	return sizeBytes;
}


void CPointers::SetArrayInt(int *array, int num)
{
	m_pArrayInt = new int[num];
	for (int i = 0; i < num; i++)
	{
		m_pArrayInt[i] = array[i];
	}

	m_LenArrayInt = num;
}


int CPointers::GetSizeArrayInts()
{
	return m_LenArrayInt * sizeof(int);
}
